%global srcname twisted

%bcond_with python_bootstrap
%bcond_with test

Summary:        Twisted is a networking engine written in Python
Name:           python-%{srcname}
Version:        23.8.0
Release:        2%{?dist}
License:        MIT
URL:            http://twistedmatrix.com/
Source0:        https://github.com/twisted/twisted/archive/%{srcname}-%{version}/%{srcname}-%{version}.tar.gz

Patch0001:      0003-11786-fix-misuse-of-mktime-in-tests.patch
#https://github.com/twisted/twisted/pull/11979
Patch0002:      fix-CVE-2023-46137.patch

Patch3001:      0001-23.8.0rc1-remove-hatch-fancy-pypi-readme.patch
Patch3002:      0002-23.8.0rc1-fix-and-skip-tests-fedora.patch

BuildArch:      noarch

%description
Twisted is a networking engine written in Python, supporting numerous protocols.
It contains a web server, numerous chat clients, chat servers, mail servers
and more.

%package -n python3-%{srcname}
Summary:        Twisted is a networking engine written in Python
BuildRequires:  python3-devel >= 3.3
BuildRequires:  python3-pyasn1-modules python3-cryptography python3-pynacl
BuildRequires:  python3-pyOpenSSL python3-bcrypt python3-subunit
%if %{with test}
BuildRequires:  python3-hamcrest python3-h2 python3-hypothesis python3-service-identity
%endif
Recommends:     python3-%{srcname}+tls

%description -n python3-%{srcname}
Twisted is a networking engine written in Python, supporting numerous protocols.
It contains a web server, numerous chat clients, chat servers, mail servers
and more.

%pyproject_extras_subpkg -n python3-%{srcname} tls

%prep
%autosetup -p1 -n %{srcname}-%{srcname}-%{version}
%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
mkdir -p %{buildroot}%{_mandir}/man1/
for s in conch core mail; do
cp -a docs/$s/man/*.1 %{buildroot}%{_mandir}/man1/
done

mkdir -p %{buildroot}%{python3_sitelib}/twisted/plugins

ln -s ./trial %{buildroot}%{_bindir}/trial-3
ln -s ./twistd %{buildroot}%{_bindir}/twistd-3

%pyproject_save_files %{srcname}
echo "%ghost %{python3_sitelib}/twisted/plugins/dropin.cache" >> %{pyproject_files}

%check
%if %{with test}
PATH=%{buildroot}%{_bindir}:$PATH PYTHONPATH="$PWD/src:%{?with_python_bootstrap:$PYTHONPATH}" \
    %{buildroot}%{_bindir}/trial twisted
%endif

%files -n python3-twisted  -f %{pyproject_files}
%license LICENSE
%doc NEWS.rst README.rst
%{_bindir}/cftp
%{_bindir}/ckeygen
%{_bindir}/conch
%{_bindir}/mailmail
%{_bindir}/pyhtmlizer
%{_bindir}/tkconch
%{_bindir}/trial
%{_bindir}/twist
%{_bindir}/twistd
%{_bindir}/trial-3
%{_bindir}/twistd-3
%{_mandir}/man1/cftp.1*
%{_mandir}/man1/ckeygen.1*
%{_mandir}/man1/conch.1*
%{_mandir}/man1/mailmail.1*
%{_mandir}/man1/pyhtmlizer.1*
%{_mandir}/man1/tkconch.1*
%{_mandir}/man1/trial.1*
%{_mandir}/man1/twistd.1*

%changelog
* Thu Jun 27 2024 Weiyao Feng <wynnfeng@tencent.com> - 23.8.0-2
- [type] security
- [desc] fix CVE-2023-46137 

* Mon Sep 25 2023 Shuo Wang <abushwang@tencent.com> - 23.8.0-1
- update to 23.8.0

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22.4.0-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Dec 20 2022 Miaojun Dong <zoedong@tencent.com> - 22.4.0-1
- initial build
